#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,float *B0,float *B1,float *B2,float *B3,float *B4,int N){
for(int i=0;i<N;i++){
A0[i] = A4[i]+A5[i]/A6[i]+A5[i];
A1[i] = A6[i]*A6[i]+A6[i]*A6[i];
A2[i] = A6[i]+A5[i]*A6[i]*A5[i];
A3[i] = A6[i]*A6[i]*A4[i]*A4[i];
B0[i] = B4[i]+B4[i]*B4[i];
B1[i] = B4[i]+B4[i]-B4[i]+B4[i];
B2[i] = B4[i]*B4[i]-B4[i];
B3[i] = B4[i];
}
}

int main(int argc,char **argv) {
int size=857695;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
int *A6;
A6 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
for(int i=0;i<857695;i++){
A0[i] = 82+i+1;
A1[i] = 65+i+1;
A2[i] = 12+i+1;
A3[i] = 25*i+1;
A4[i] = 39+i+1;
A5[i] = 98*i+1;
A6[i] = 39+i+1;
B0[i] = 93.7904085188*i+1;
B1[i] = 7.6862023688+i+1;
B2[i] = 41.0303546375*i+1;
B3[i] = 74.3507454954*i+1;
B4[i] = 30.4516018161*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,A5,A6,B0,B1,B2,B3,B4,857695);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(A5);
free(A6);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
printf("\n");return 0; }